def __init__(self, shape): if not shape.IsNull(): if not shape.ShapeType() == Shape.SHELL: raise TypeError('Shape is not a TopoDS_Shell.') if not isinstance(shape, TopoDS_Shell): shape = TopoDS.Shell_(shape) super(Shell, self).__init__(shape)
def to_shell(cls, entity): """ Convert an entity to a shell. :param entity: The entity. :return: A shell. :rtype: OCCT.TopoDS.TopoDS_Shell :raise TypeError: If entity cannot be converted to a shell. """ if isinstance(entity, TopoDS_Shell): return entity if cls.is_shape(entity) and entity.ShapeType() == TopAbs_SHELL: return TopoDS.Shell_(entity) if cls.is_shape(entity) and entity.ShapeType() == TopAbs_FACE: shell = TopoDS_Shell() builder = BRep_Builder() builder.MakeShell(shell) builder.Add(shell, entity) return shell raise TypeError('Failed to convert entity to a shell.')
def get_shells(shape): """ Get shells from a shape. :param OCCT.TopoDS.TopoDS_Shape shape: The shape. :return: Shells of shape. :rtype: list[OCCT.TopoDS.TopoDS_Shell] """ if isinstance(shape, TopoDS_Shell): return [shape] exp = TopExp_Explorer(shape, TopAbs_SHELL) shells = [] while exp.More(): si = exp.Current() shell = TopoDS.Shell_(si) shells.append(shell) exp.Next() return shells
def to_shape(cls, entity): """ Convert the entity to a shape. This method tries to convert the entity to its most specific shape type. :param entity: The entity. :return: A shape. :rtype: OCCT.TopoDS.TopoDS_Shape :raise TypeError: If entity cannot be converted to a shape. """ if entity is None: return None # Shapes if isinstance(entity, TopoDS_Shape): if entity.IsNull(): raise TypeError('Cannot convert null shape.') elif entity.ShapeType() == TopAbs_VERTEX: return TopoDS.Vertex_(entity) elif entity.ShapeType() == TopAbs_EDGE: return TopoDS.Edge_(entity) elif entity.ShapeType() == TopAbs_WIRE: return TopoDS.Wire_(entity) elif entity.ShapeType() == TopAbs_FACE: return TopoDS.Face_(entity) elif entity.ShapeType() == TopAbs_SHELL: return TopoDS.Shell_(entity) elif entity.ShapeType() == TopAbs_SOLID: return TopoDS.Solid_(entity) elif entity.ShapeType() == TopAbs_COMPSOLID: return TopoDS.CompSolid_(entity) elif entity.ShapeType() == TopAbs_COMPOUND: return TopoDS.Compound_(entity) else: raise TypeError('Failed to convert entity to a shape.') raise TypeError('Failed to convert entity to a shape.')